
/**
 * Basis Barcode scanner with GM65 module
 * Wemos 1D mini controllerboard
 * 
 * Developed by Jeff Schilders (jeff@schilders.com)
 * Lastupdatwe: 23-10-2019
 * 
 * TODO:
 * Change GET to POST request.
 */
#include <SoftwareSerial.h>
#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>

#define LED D5
#define ERRORLED D1
#define CO2_TX D3
#define CO2_RX D2


const char* ssid = "xxxxxxx";
const char* password = "xxxxxx";


String webserver ="https://***************";
/** SHA 1 Fingerprint SSL **/ 
const char* fingerprint = "***************";

String room = "L23";



String qrcode;
char str; 

SoftwareSerial gtSerial(CO2_RX, CO2_TX); // RX, TX
HTTPClient http; 
 
void setup() {
  pinMode(LED, OUTPUT);
  pinMode(ERRORLED, OUTPUT);
  delay(10);
  digitalWrite(LED, LOW);
  digitalWrite(ERRORLED, HIGH);
  
  Serial.begin(115200);
  gtSerial.begin(9600);  // software serial port  
  delay(10);
  
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print("."); 
     delay(500);
  }
  digitalWrite(ERRORLED, LOW);
  digitalWrite(LED, HIGH);
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.print(WiFi.localIP());
  Serial.println("\n");
  long rssi = WiFi.RSSI();
  Serial.print("Signal (RSSI): ");
  Serial.print(rssi);
  Serial.println(" dBm");
  Serial.println("");
  delay(1000);
  digitalWrite(LED, LOW);
}
 
void loop() {
  
 while (gtSerial.available()>0){
  char str = gtSerial.read();
  if(str=='#'){
    qrcode.trim();
    Serial.println(qrcode);
    settoserver();
    
   } else {
    qrcode=qrcode+str;
   }
 }

  
}

void settoserver(){
   if(WiFi.status()== WL_CONNECTED){   //Check WiFi connection status
     Serial.println("Send payload"); 
     
     
     /** Send payload to server **//
     String PostData = "?code="+qrcode+"&device="+room;
     
     String httpget = webserver+PostData;
     Serial.println(httpget);
     if(http.begin(httpget,fingerprint)){    
 
       int httpCode = http.GET();  
       delay(1500);  
       
       Serial.println(httpCode);
       if (httpCode > 0) {
        Serial.printf("[HTTP] GET... code: %d\n", httpCode);
         if(httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) {
           String payload = http.getString();                 
           if (payload != "false"){
              Serial.println(payload); 
              digitalWrite(LED, HIGH);
              delay(1500);  
              digitalWrite(LED, LOW);
           } else {
            Serial.println("Bad Playload");
              digitalWrite(ERRORLED, HIGH);
              delay(1500);  
              digitalWrite(ERRORLED, LOW);
           }
         } else {
           
         }
       } else {
        Serial.println("Error sending to HTTP");
       }
       http.end(); 
     } 
   }else{
    Serial.println("Error in WiFi connection");   
   } 
   qrcode=""; 
}
